
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Purchase_invoice_linesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const purchase_invoice_lines = await db.purchase_invoice_lines.create(
            {
                id: data.id || undefined,
        
        description: data.description
        ||
        null
            ,
            
        quantity: data.quantity
        ||
        null
            ,
            
        unit_price: data.unit_price
        ||
        null
            ,
            
        line_subtotal: data.line_subtotal
        ||
        null
            ,
            
        vat_treatment: data.vat_treatment
        ||
        null
            ,
            
        vat_amount: data.vat_amount
        ||
        null
            ,
            
        line_total: data.line_total
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await purchase_invoice_lines.setPurchase_invoice( data.purchase_invoice || null, {
            transaction,
        });
        
        await purchase_invoice_lines.setProduct( data.product || null, {
            transaction,
        });
        
        await purchase_invoice_lines.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return purchase_invoice_lines;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const purchase_invoice_linesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                description: item.description
            ||
            null
            ,
            
                quantity: item.quantity
            ||
            null
            ,
            
                unit_price: item.unit_price
            ||
            null
            ,
            
                line_subtotal: item.line_subtotal
            ||
            null
            ,
            
                vat_treatment: item.vat_treatment
            ||
            null
            ,
            
                vat_amount: item.vat_amount
            ||
            null
            ,
            
                line_total: item.line_total
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const purchase_invoice_lines = await db.purchase_invoice_lines.bulkCreate(purchase_invoice_linesData, { transaction });

        // For each item created, replace relation files
        

        return purchase_invoice_lines;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const purchase_invoice_lines = await db.purchase_invoice_lines.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.quantity !== undefined) updatePayload.quantity = data.quantity;
        
        
        if (data.unit_price !== undefined) updatePayload.unit_price = data.unit_price;
        
        
        if (data.line_subtotal !== undefined) updatePayload.line_subtotal = data.line_subtotal;
        
        
        if (data.vat_treatment !== undefined) updatePayload.vat_treatment = data.vat_treatment;
        
        
        if (data.vat_amount !== undefined) updatePayload.vat_amount = data.vat_amount;
        
        
        if (data.line_total !== undefined) updatePayload.line_total = data.line_total;
        
        
        updatePayload.updatedById = currentUser.id;

        await purchase_invoice_lines.update(updatePayload, {transaction});

        
        
        if (data.purchase_invoice !== undefined) {
            await purchase_invoice_lines.setPurchase_invoice(
              
              data.purchase_invoice,
              
              { transaction }
            );
        }
        
        if (data.product !== undefined) {
            await purchase_invoice_lines.setProduct(
              
              data.product,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await purchase_invoice_lines.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return purchase_invoice_lines;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const purchase_invoice_lines = await db.purchase_invoice_lines.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of purchase_invoice_lines) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of purchase_invoice_lines) {
                await record.destroy({transaction});
            }
        });


        return purchase_invoice_lines;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const purchase_invoice_lines = await db.purchase_invoice_lines.findByPk(id, options);

        await purchase_invoice_lines.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await purchase_invoice_lines.destroy({
            transaction
        });

        return purchase_invoice_lines;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const purchase_invoice_lines = await db.purchase_invoice_lines.findOne(
            { where },
            { transaction },
        );

        if (!purchase_invoice_lines) {
            return purchase_invoice_lines;
        }

        const output = purchase_invoice_lines.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.purchase_invoice = await purchase_invoice_lines.getPurchase_invoice({
            transaction
        });
        
        
        output.product = await purchase_invoice_lines.getProduct({
            transaction
        });
        
        
        output.organizations = await purchase_invoice_lines.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.purchase_invoices,
        as: 'purchase_invoice',
        
        where: filter.purchase_invoice ? {
          [Op.or]: [
            { id: { [Op.in]: filter.purchase_invoice.split('|').map(term => Utils.uuid(term)) } },
            {
              invoice_number: {
                [Op.or]: filter.purchase_invoice.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.products,
        as: 'product',
        
        where: filter.product ? {
          [Op.or]: [
            { id: { [Op.in]: filter.product.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.product.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'purchase_invoice_lines',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.quantityRange) {
                const [start, end] = filter.quantityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.unit_priceRange) {
                const [start, end] = filter.unit_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    unit_price: {
                    ...where.unit_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    unit_price: {
                    ...where.unit_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.line_subtotalRange) {
                const [start, end] = filter.line_subtotalRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    line_subtotal: {
                    ...where.line_subtotal,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    line_subtotal: {
                    ...where.line_subtotal,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.vat_amountRange) {
                const [start, end] = filter.vat_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    vat_amount: {
                    ...where.vat_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    vat_amount: {
                    ...where.vat_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.line_totalRange) {
                const [start, end] = filter.line_totalRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    line_total: {
                    ...where.line_total,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    line_total: {
                    ...where.line_total,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.vat_treatment) {
                where = {
                    ...where,
                vat_treatment: filter.vat_treatment,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.purchase_invoice_lines.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'purchase_invoice_lines',
                        'description',
                        query,
                    ),
                ],
            };
        }

        const records = await db.purchase_invoice_lines.findAll({
            attributes: [ 'id', 'description' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['description', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.description,
        }));
    }

    
};

